\section{Proposed method}

\begin{frame}{Proposed method}{Intro}
\begin{itemize}
    \item fixed $K \Rightarrow$ set a random, fixed (and plausible) one $\Rightarrow$ dataset re-sampling needed!
    \item just focus on learning camera information (via \textit{some} NN architecture) and then do triangulation (via \textit{algebraic} DLT)
    \item implementation POV: can use available $2D$ detectors (or even ground-truth keypoints)
\end{itemize}
\end{frame}

\begin{frame}{Proposed method}{Pipeline}
\begin{enumerate}
    \item $2D$-detect
    \item estimate camera information ($R \mid t$): \textbf{this is what our method actually solve}
    \item lift
    \item $\mathcal{L}$ on the re-projection in other views (needed at least 2 cameras)
\end{enumerate}
\end{frame}

\subsection{Learning camera information}

\begin{frame}{Learning camera information}{$R \mid t$ usual representations}
\begin{itemize}
    \item Euler angles, \eg{} "proper" $(z-x-z, x-y-x, y-z-y, z-y-z, x-z-x, y-x-y)$
    \item angle-axis
    \item quaternions
    \item dual quaternions \textbf{would be very handy, but also a bit tricky} (not discussed in depth here)
\end{itemize}
\end{frame}

\begin{frame}{$R \mid t$ usual representations}{Euler angles}
\centering
\begin{figure}
    \adjincludegraphics[width=.5\linewidth]{\imgDir/eulers.png}
    \caption{Visualization of discontinuities \say{near gimbals lock} in 3D rotation representations, adapted from \cite{6d_mat_param}}
\end{figure}
\end{frame}

\begin{frame}{$R \mid t$ usual representations}{angle-axis}
\begin{theorem}[Euler's rotation theorem]
    With respect to a 3D point of a rigid object, a rotation can be represented as an axis (the rotation axis) and a scalar (the angle of the rotation). This is often called \textbf{axis–angle representation}.
\end{theorem}

\begin{figure}
    \adjincludegraphics[width=.1\linewidth]{\imgDir/aa_repr.png}
    \caption{The angle $\theta$ and axis unit vector $\mathbf{e}$ define a rotation, concisely represented by the rotation vector $\theta \mathbf{e}$, \copyright{} Maschen}
\end{figure}

\vfill
... as used in \cite{mahendran20173d}
\end{frame}

\begin{frame}{$R \mid t$ usual representations}{Quaternions}
\begin{itemize}
    \item vector $\vec{u}$
    \item (scalar) angle $\theta$
\end{itemize}

\begin{align}
    \vec {u} &=(u_{x},u_{y},u_{z})\\
    &=u_{x}\mathbf {i} +u_{y}\mathbf {j} +u_{z}\mathbf {k}\\
    \mathbf {q} &= e^{{\frac {\theta }{2}}{(u_{x}\mathbf {i} +u_{y}\mathbf {j} +u_{z}\mathbf {k} )}}\\
    &=\cos {\frac {\theta }{2}}+(u_{x}\mathbf {i} +u_{y}\mathbf {j} +u_{z}\mathbf {k} )\sin {\frac {\theta }{2}}
\end{align}
\end{frame}

\begin{frame}{$R \mid t$ usual representations}{Problems}
\say{for 3D rotations, ALL representations are discontinuous in the real 
Euclidean spaces of four or fewer dimensions} \footnote{\cite{6d_mat_param}}

\begin{figure}
    \adjincludegraphics[width=.5\linewidth]{\imgDir/problem_reprs.png}
    \caption{Discontinuities in $\le 4-D$ rotation representations, from \cite{6d_mat_param}}
\end{figure}
\end{frame}

\begin{frame}{Learning camera information}{$R \mid t$ proposed representation}
\begin{itemize}
    \item represent $R \in SO(3)$ using 6 parameters as in \cite{6d_mat_param}
    \item represent \say{directly} $t \in \mathbb{R} ^ 3$
\end{itemize}
\end{frame}

\begin{frame}{Learning camera information}{$R$ representation via \cite{6d_mat_param}}
\begin{itemize}
    \item mapping from $SO(3)$ (matrix) to a $6D$ representation by simply \say{dropping the last column vector of the input matrix} { \small\begin{equation}
        g_{\mathrm{GS}} \left( \left[ {\begin{array}{ccc}
            \vert & \vert & \vert \\
            a_1 & a_2 & a_3 \\
            \vert & \vert & \vert
            \end{array} } \right] \right) = 
            \left[ {\begin{array}{ccc}
            \vert & \vert \\
            a_1 & a_2 \\
            \vert & \vert
            \end{array} } \right]
        \label{eqn:gramschmidt_repr}
        \end{equation}}
    \item mapping from $6D$ representation to $SO(3)$ ($\sim$ Gram-Schmidt orthogonalization)
\end{itemize}
{ \small\begin{equation}
f_{\mathrm{GS}}\left(\left[ {\begin{array}{ccc}
    \vert & \vert \\
    a_1 & a_2 \\
    \vert & \vert
    \end{array} } \right]\right) = 
    \left[ {\begin{array}{ccc}
    \vert & \vert & \vert \\
    b_1 & b_2 & b_3 \\
    \vert & \vert & \vert
    \end{array} } \right],\quad b_i = \left[ \begin{cases}
N(a_1) & \text{if } $i=1$ \\
N(a_2 - (b_1 \cdot a_2) \cdot b_1) & \text{if } $i=2$ \\
b_1 \times b_2 & \text{if } $i=3$
\end{cases}
\right]^T
\label{eqn:gramschmidt}
\end{equation}}

where $N(q) = \frac{q}{\| q \|}$
\end{frame}

\begin{frame}{Learning camera information}{\texttt{MLPResNet} block}
\centering
\begin{figure}
    \adjincludegraphics[width=.12\linewidth]{\imgDir/archs-MLPResNet.png}
    \caption{\texttt{MLPResNet} block}
\end{figure}
\end{frame}

\begin{frame}{Pipeline}{Experiments}
\begin{itemize}
    \item \vone: naive
    \item \vtwo: DLT in camspace
    \item \vort: model cameras with orthogonal projection (using \vone's pipeline)
\end{itemize}
\end{frame}

\begin{frame}{Pipeline: \vone}{\texttt{RotoTransNet}}
\begin{columns}

\begin{column}{.5\textwidth}
\centering
\begin{figure}
    \adjincludegraphics[width=.25\linewidth]{\imgDir/archs-RotoTransNet.png}
    \caption{\texttt{RotoTransNet} architecture}
\end{figure}
\end{column}

\begin{column}{.5\textwidth}
\centering
\begin{itemize}
    \item perform DLT in world space
    \item preliminary representation with a shallow \texttt{MLPResNet} ...
    \item then building the actual rotation matrix (via $6D$ parametrization, \texttt{Rodrigues} block)
    \item $t$ is directly regressed via a \texttt{MLPResNet}
\end{itemize}
\end{column}
\end{columns}
\end{frame}

\begin{frame}{Pipeline: \vtwo}{\texttt{Cam2camNet}}
\begin{columns}

\begin{column}{.5\textwidth}
\centering
\begin{figure}
    \adjincludegraphics[width=.32\linewidth]{\imgDir/archs-Cam2camNet.png}
    \caption{\texttt{Cam2camNet} architecture}
\end{figure}
\end{column}

\begin{column}{.5\textwidth}
    \centering
    \begin{itemize}
        \item perform DLT in \say{master} camera space
        \item $\Rightarrow$ need to recover $R \mid t$ of \say{master} camera ...
        \item ... and \textit{relative} roto-translation from \say{master} camera to others
    \end{itemize}
\end{column}
\end{columns}
\end{frame}

\begin{frame}{Loss}{Experiments}
    \begin{itemize}
        \item supervised setting, \ie{} using ground-truth $R$, keypoints
        \item unsupervised setting, \ie{} using multi-view self-consistencies
    \end{itemize}
\end{frame}

\begin{frame}{Loss under supervision}{$\mathcal{L}_{\text{geodesic}}$}
\centering
\say{the minimal angular difference between 2 rotations}, \cite{6d_mat_param}

\begin{align}
\mathcal{L}_{\text{geodesic}} &= \cos ^{-1}((M''_{00}+M''_{11}+M''_{22}-1)/2)\\
M'' &= MM'^{-1}
\label{eq:geodesic_distance}
\end{align}

\begin{figure}
\adjincludegraphics[width=.2\linewidth]{\imgDir/loss/geo.png}
\caption{Geodesic error (distance) between 2 rotations (angle-axis representation)}
\end{figure}
\end{frame}

\begin{frame}{Loss under supervision}{$\mathcal{L}_{\text{berHu}}$}
\begin{equation}
    \label{eq:l_berHu}
    \mathcal{L}_{\text{berHu}}(x) = \begin{cases}
        \mid x \mid &\text{if} \quad \mid x \mid \le L\\
        \frac{x ^ 2 + L ^ 2}{2L} &\text{else}
    \end{cases}
\end{equation}
from \cite{berhu_loss}

\begin{columns}

    \begin{column}{.5\textwidth}
    \centering
    \begin{figure}
    \adjincludegraphics[width=.6\linewidth]{\imgDir/loss/Huber.png}
    \caption{$\mathcal{L}_{\text{Huber}}$}
    \end{figure}
    \end{column}
    
    \begin{column}{.5\textwidth}
    \centering
    \begin{figure}
    \adjincludegraphics[width=.6\linewidth]{\imgDir/loss/berHu.png}
    \caption{$\mathcal{L}_{\text{berHu}}$}
    \end{figure}
    
    \end{column}
\end{columns}
\end{frame}

\begin{frame}{Loss under supervision}{Final form}
\begin{enumerate}
    \item reconstruct 3D pose
    \item apply $\mathcal{L}_{\text{berHu}}$ against ground-truth poses (3D, projections) $+ \mathcal{L}_{\text{geodesic}}$ between predicted $R$ and groun-truth ones
\end{enumerate}
\end{frame}

\begin{frame}{Loss under \textbf{no} supervision}{Final form}
\begin{enumerate}
    \item reconstruct 3D pose
    \item re-project pose to other views
    \item normalize (scale-invariant loss)
    \item apply $\mathcal{L}_{\text{berHu}}$ against input detections in each view
\end{enumerate}
\end{frame}

\section{Proposed pipeline}

\begin{frame}{Pipeline}{Pre-processing}
\begin{enumerate}
    \item ensure to have same $K$, \ie{} resampe!
    \item $2D$-joint detect (\eg{} \cite{alphapose})
    \item normalization (using Frobenius norm)
    \item center to root (\eg{} pelvis)
\end{enumerate}
\end{frame}

\begin{frame}{Pipeline}{Post-processing}
\begin{enumerate}
    \item \textbf{MPJPE} $\to$ \textbf{PMPJPE}, \ie{} Procrustes-align (via \cite{umeyama_ls})
    \item \textbf{PMPJPE} $\to$ \textbf{NMPJPE}, \ie{} re-scale \wrt{} ground-truth
    \item root joint $\to (0, 0, 0)$
\end{enumerate}
\end{frame}

\begin{frame}{Pipeline}{Training regime}
\begin{itemize}
    \item Adam (\cite{adam_optim}) ...
    \item ... combined with \textbf{weight decay} as in \cite{adam_optim_weight_decay}
    \item ... and \textbf{gradient clipping} (like in \cite{grad_clipping}) to improve stability
\end{itemize}
\end{frame}
